unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  MSCryptoAPI;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    Edit4: TEdit;
    Label4: TLabel;
    RadioGroup1: TRadioGroup;
    Label5: TLabel;
    Edit5: TEdit;
    Label6: TLabel;
    Edit6: TEdit;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    hProv: HCRYPTPROV;
    AProvType, AFlags: DWORD;
    Provider: PChar;
    AAlgKey, AAlgHash: Cardinal;
    hash: HCRYPTHASH;
    APassword: String;
    key: HCRYPTKEY;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  FResult: String;
  ln, sz: LongWord;
  i: integer;
begin
  AProvType := PROV_RSA_AES;
  AFlags := CRYPT_VERIFYCONTEXT;
  AAlgHash := CALG_SHA;
  APassword := Edit1.Text;
  AAlgKey := CALG_AES_256;
  Provider := MS_ENH_RSA_AES_PROV;
  try
    if not CryptAcquireContext(@hProv, 0, Provider, AProvType, AFlags) then
      RaiseLastOSError;
    if not CryptCreateHash(hProv, AAlgHash, 0, 0, @hash) then
      RaiseLastOSError;
    if not CryptHashData(hash, @APassword[1], length(APassword), 0) then
      RaiseLastOSError;
    Edit2.Text := InttoStr(hash);
    if not CryptDeriveKey(hProv, AAlgKey, hash, 0, @key) then
      RaiseLastOSError;
    Edit6.Text := InttoStr(key);
    FResult := Edit3.Text + #0;
    SetLength(FResult, length(FResult) - 1);
    sz := length(FResult);
    ln := sz;
    CryptEncrypt(key, 0, true, 0, @FResult[1], @ln, sz);
    if GetLastError = ERROR_MORE_DATA then
    begin
      SetLength(FResult, ln);
      CryptEncrypt(key, 0, true, 0, @FResult[1], @sz, ln);
    end;
    SetLength(FResult, sz);
    Edit5.Text := '';
    for i := 1 to length(FResult) do
      Edit5.Text := Edit5.Text + InttoHex(Ord(FResult[i]), 2);
  finally
    if key <> 0 then
      CryptDestroyKey(key);
    if hash <> 0 then
      CryptDestroyHash(hash);
    if hProv <> 0 then
      CryptReleaseContext(hProv, 0);
  end;

end;

end.